petsc-3.13.6 2020-09-29
Report Typos and Errors

# DMTSSetTransientVariable

sets function to transform from state to transient variables

### Synopsis

    #include "petscts.h"
    PetscErrorCode DMTSSetTransientVariable(DM dm,TSTransientVariable tvar,void *ctx)

Logically Collective

### Input Arguments

| dm | - DM to be used with TS
| tvar | - a function that transforms in-place to transient variables
| ctx | - a context for tvar

### Notes

This is typically used to transform from primitive to conservative variables so that a time integrator (e.g., TSBDF) can be conservative. In this context, primitive variables P are used to model the state (e.g., because they lead to well-conditioned formulations even in limiting cases such as low-Mach or zero porosity). The transient variable is C(P), specified by calling this function. An IFunction thus receives arguments (P, Cdot) and the IJacobian must be evaluated via the chain rule, as in

dF/dP + shift * dF/dCdot dC/dP.

### See Also

TSSetTransientVariable(), DMTSGetTransientVariable(), DMTSSetIFunction(), DMTSSetIJacobian()

### Level

advanced

### Location

src/ts/utils/dmts.c
Index of all TS routines
Table of Contents for all manual pages
Index of all manual pages